import React, { Component } from 'react';
import { reduxForm, Field } from 'redux-form';
import { Link } from 'react-router-dom';
import{buscarClientePorFactura} from '../../actions/AccionesFacturas';

const validaciones = valores => {
  const errores = {};
  if (!valores.nombre) {
    errores.nombre = 'Nombre es requerido';
  } else if (valores.nombre && valores.nombre.length < 5) {
    errores.nombre = 'Debe contener al menos 5 caracteres';
  }if(!valores.total){
    errores.total='Total Requerido'
}else if(isNaN(valores.total)){
    errores.total=' Debes ingresar números';
}
  // if (!values.email) {
  //   errors.email = 'Required'
  // } else if (!/^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}$/i.test(values.email)) {
  //   errors.email = 'Invalid email address'
  // }
  // if (!values.age) {
  //   errors.age = 'Required'
  // } else if (isNaN(Number(values.age))) {
  //   errors.age = 'Must be a number'
  // } else if (Number(values.age) < 18) {
  //   errors.age = 'Sorry, you must be at least 18 years old'
  // }
  return errores;
};

class FormularioFactura extends Component {
  componentWillReceiveProps = nextProps => {
    // Load Contact Asynchronously
    const { factura } = nextProps;
    if (factura._id !== this.props.factura._id) {
      // Initialize form only once
      this.props.initialize(factura);
      this.setState({detalle: factura.detalle});
      this.setState({producto: detalle.producto});
      this.setState({cliente: factura.cliente});
      this.estaActualizando = true;
    }
    
  };

  renderField = ({ input, label, type, meta: { touched, error } }) => (
    <div className='form-group'>
      <label forname={input.name}>{label}</label>
      <input
        {...input}
        type={type}
        className='form-control'
        id={input.name}
        placeholder={input.label}
      />
      <div className='text-danger' style={{ marginBottom: '20px' }}>
        {touched && error}
      </div>
    </div>
  );
  renderDetalle = ({fields, meta: { error,submitFailed }}) =>(

          <ul>        
            <li>
         <button type="button" onClick={() => fields.push({})}>
              Agregar detalle
          </button>
            {submitFailed && error && <span>{error}</span>}
             </li>
          
             {fields.map((detalle, index) => (
      <li key={index}>
        <button
          type="button"
          title="eliminar detalle"
          onClick={() => fields.remove(index)}
        />
        <h4>Detalle #{index + 1}</h4>
        <Field
          name={`${detalle}.cantidad`}
          type="text"
          component={renderField}
          label="Cantidad"
        />
       
        <FieldArray name={`${detalle}.producto`} component={renderProducto} label="Producto" />
        <Field
          name={`${detalle}.subtotal`}
          type="text"
          component={renderField}
          label="Subtotal"
        />
      </li>
    ))}


          </ul>);

  renderProducto = ({fields, meta: { error }}) => (
  
          <ul>
              <li>
      <button type="button" onClick={() => fields.push()}>
          Agregar producto
      </button>
      {error && <li className="error">{error}</li>}
    </li>
    {fields.map((producto) => (
      <li key={producto._id}>
        <button
          type="button"
          title="Eliminar producto"
          onClick={() => fields.remove(producto._id)}
        />
        <Field
          name={producto.codigo}
          type="text"
          component={renderField}
          label= "codigo"
        />
        <Field
          name={producto.nombre}
          type="text"
          component={renderField}
          label= "Nombre"
        />
        <Field
          name={producto.precio}
          type="text"
          component={renderField}
          label= "Precio"
        />
      </li>
    ))}

         </ul>);

         renderCliente = ({ error,handleInputChange }) => (

          <div className="col-md-4 mb-3">
          <label >Cliente:</label>
          {handleInputChange && error && <span>{error}</span>}
          <select className="custom-select d-block w-100"  value={this.state.cliente} name="cliente" onChange={this.handleInputChange} >
          
         { this.props.clientesDs.map(cliente => {
  
               return(
                       <option  key={cliente._id}  value={cliente._id}>{cliente.nombre}</option>
                      )
                       })}
          </select>
          </div>

         );

  render() {
    const { handleSubmit, cargando } = this.props;

    if (cargando) {
      return <span>Cargando...</span>;
    }
    

    return (
      <form onSubmit={handleSubmit}>
        <Field
          name='numero'
          type='text'
          component={this.renderField}
          label='Numero'
        />
         <Field
          name='tipo'
          type='text'
          component={this.renderField}
          label='Tipo'
        />
         <Field
          name='sucursal'
          type='text'
          component={this.renderField}
          label='Sucursal'
        />
        
        <Field
          name='cliente'
         type='text'
          component={this.renderCliente}
          label='Cliente'
        />  
          
        
        <FieldArray
          name='detalle'
          component={this.renderDetalle}
          label='Detalle'
        /><div>
        <button type="submit" disabled={submitting}>
          Confirmar
        </button>
        <button type="button" disabled={pristine || submitting} onClick={reset}>
          Eliminar valores
        </button>
      </div>
        <Field
          name='total'
          type='text'
          component={this.renderField}
          label='Total'
        />
        <Link className='btn btn-light mr-2' to='/facturas'>
          Cancelar
        </Link>
        <button className='btn btn-primary mr-2' type='submit'>
          {this.estaActualizando ? 'Actualizar' : 'Crear'}
        </button>
      </form>
    );
  }
}
function mapStateToProps(state){
  return {
      listaClientes:state.clientesDs.listaClient
  }
}

export default reduxForm(mapStateToProps,{buscarClientePorFactura},{ form: 'factura', validate: validaciones })(FormularioFactura);
//<Field
        //  name='cliente'
       //   type='text'
        //  component={this.renderField}
       //   label='Cliente'
       // />   