import React, { Component } from 'react';
import { connect } from 'react-redux';
import { buscarFacturas, eliminarFactura,buscarClientePorFactura} from '../../actions';
import { Link } from 'react-router-dom';

class ListarFactura extends Component {
  componentDidMount() {
    this.props.buscarFacturas();
    this.setState({detalle: listaFacturas.detalle});
    this.setState({producto: listaFacturas.detalle.producto});
    this.setState({cliente: listaFacturas.cliente});
    this.setState({direccion: listaFacturas.cliente.direccion});
    this.props.buscarClientePorFactura();
  }
crearDetalle(){
  return this.props.detalle.map((detalle,index) =>{
    return(
   
        <tr key={index}>
        
        <td>{detalle.cantidad}</td>
        <td>{detalle.subtotal}</td>
        
        
        <table className='table table-striped table-sm'>
        <thead>
          <tr>
          <th>Codigo</th>
          <th>Nombre</th>
          <th>Precio</th>


          </tr>

        </thead>
        <tbody>{this.crearProducto()}</tbody>
        </table>
        </tr>

      
    )
  });
} 
crearProducto(){
  return this.props.producto.map((producto) =>{
    return(
      
        <tr key={producto._id}>
        <td>{producto.codigo}</td>
        <td>{producto.nombre}</td>
        <td>{producto.precio}</td>  
        </tr>
      
      
    )
  });
} 
crearCliente(){
    return this.props.cliente.map(cliente =>{
      return(

      <tr key={cliente._id}>
             <td>{cliente.nombre}</td>
             <td>{cliente.email}</td>
             <td>{cliente.cuil}</td>
             <td>{cliente.telefono}</td>
      
      
      <table ClassName='table table-striped table-sm'>
      <thead>
        <th>Calle</th>
        <th>Numero</th>
        <th>Piso</th>
        <th>Departamento</th>

      </thead>

      <tbody>{this.crearDireccion()}</tbody>
      
      
      </table>
      </tr>
      )
    })
}
crearDireccion(){
  return this.props.direccion.map(direccion => {
    return(
      <div>
    <tr key= {direccion._id}>
                <td>{direccion.calle}</td>
                <td>{direccion.numero}</td>
                <td>{direccion.piso}</td>
                <td>{direccion.departamento}</td>
    
    
    </tr>
    </div>
  )
  })
}


  crearFilas() {
    return this.props.listaFacturas.map(factura => {
      return (
        
        <tr key={factura._id}>
          <td>{factura.numero}</td>
          <td>{factura.fecha}</td>
          <td>{factura.tipo}</td>
          <td>{factura.sucursal}</td>
          <td>{factura.total}</td>


              
          <table className='table table-striped table-sm'>
              <thead>
                <th>nombre</th>
                <th>email</th>
                <th>cuil</th>
                <th>telefono</th>
                
              </thead>
              <tbody>{this.crearCliente()}</tbody>
          
          </table>
          <table className='table table-striped table-sm'>
            <thead> 
                <th> cantidad</th>
                <th>subtotal</th>
                <th>Producto</th>

            </thead>
            <tbody>
              {this.crearDetalle()}
            </tbody>

          </table>
         

          
          <td>
            <Link to={`/facturas/${factura._id}/ver`} className='mr-2'>
              Ver
            </Link>
            <Link to={`/facturas/${factura._id}/editar`} className='mr-2'>
              Editar
            </Link>
            <a
              className='mr-2'
              href='#more'
              onClick={() => {
                if (
                  window.confirm(
                    '¿Está usted seguro que desea eliminar la factura?'
                  )
                )
                  this.props.eliminarFactura(factura._id);
              }}
            >
              Eliminar
            </a>
          </td>
        </tr>
        
      );
    });
  }

  render() {
    return (
      <div>
        <h2>Listando Facturas</h2>

        <p>
          <Link to='/facturas/nueva' className='btn btn-primary'>
            Nuevo
          </Link>
        </p>

        <div className='table-responsive'>
          <table className='table table-striped table-sm'>
            <thead>
              <tr>
                <th>Numero</th>
                <th>Fecha</th>
                <th>Tipo</th>
                <th>Sucursal</th>
                <th>Cliente</th>
                <th>Detalle</th>
                <th>Total</th>
                <th>Acciones</th>
              </tr>
            </thead>
            <tbody>{this.crearFilas()}</tbody>
          </table>
        </div>
      </div>
    );
  }
}

function mapState(state) {
  return {
    listaFacturas: state.facturassDs.listaFacturas,
    listaClientes: state.clientesDS.clientes
  };
}

const actions = {
  buscarFacturas,
  eliminarFactura,
  buscarClientePorFactura
};

export default connect(
  mapState,
  actions
)(ListarFactura);
