import React, { Component } from 'react';

import { connect } from 'react-redux';
import { Redirect } from 'react-router';
import { SubmissionError } from 'redux-form';
import { nuevaFactura, guardarFactura,buscarClientePorFactura } from '../../actions/AccionesFacturas';
import FormularioFactura from './FormularioFactura';

class NuevaFactura extends Component {
  state = {
    redirect: false
  };

  componentDidMount() {
    this.props.nuevaFactura();
    this.props.buscarClientePorFactura();
    this.setState({cliente: factura.cliente});
  }

  submit = (factura,cliente) => {
    return this.props
      .guardarFactura(factura)
      .then(response => this.setState({ redirect: true }))
      .catch(err => {
        throw new SubmissionError(this.props.errores);
      });
     return this.props
      .buscarClientePorFactura(cliente)
      .then(response => this.setState({redirect: true}))
      .catch(err => {
        throw new SubmissionError(this.props.errores);
      });
  };
 

  render() {
    return (
      <div>
        <h2>Nueva Factura</h2>

        {this.state.redirect ? (
          <Redirect to='/facturas' />
        ) : (
          <FormularioFactura factura={this.props.factura} cliente={this.props.cliente} onSubmit={this.submit} />
        )}
      </div>
    );
  }
}

function mapStateToProps(state) {
  return {
    factura: state.facturasDs.factura,
    clientes: state.clientesDS.clientes,
    errores: state.facturasDs.errores
  };
}

export default connect(
  mapStateToProps,
  { nuevaFactura, guardarFactura, buscarClientePorFactura }
)(NuevaFactura);
